fix mistake from recent commit
[distro-setup] / check-subvol-stale
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
18
19 set -eE -o pipefail
20 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
21
22 shopt -s nullglob
23
24 usage() {
25 cat <<EOF
26 usage: $0 SUBVOL_MOUNTPOINT...
27
28 In git this is not not executable because it's meant to be installed
29 using ./install-my-scripts
30
31 If latest subvols \$@ are not mounted, print a message, and print
32 the unstale subvol name into /nocow/btrfs-stale/\$subvol
33
34 Fresh is opposite of stale. To be fresh, either SUBVOL_MOUNTPOINT is a
35 snapshot of the latest, or the latest snapshot is snapshot of
36 SUBVOL_MOUNTPOINT.
37
38 -d Enable debug output
39 -h|--help Print help and exit.
40
41 Note: Uses GNU getopt options parsing style
42 EOF
43 exit $1
44 }
45
46 ##### begin command line parsing ########
47
48 debug=false # default
49 temp=$(getopt -l help,d hd "$@") || usage 1
50 eval set -- "$temp"
51 while true; do
52 case $1 in
53 -d) debug=true; shift ;;
54 -h|--help) usage ;;
55 --) shift; break ;;
56 *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
57 esac
58 done
59
60 if [[ ! $@ ]]; then
61 echo "$0: error: expected mountpoint argument"
62 fi
63
64 stale-file() {
65 stale_dir=/nocow/btrfs-stale
66 stale_file=$stale_dir/$vol
67 if $stale; then
68 mkdir -p $stale_dir
69 printf "%s\n" $freshest_snap > $stale_file
70 else
71 rm -f $stale_file
72 fi
73
74 }
75 d() {
76 if $debug; then
77 printf "%s\n" "$*"
78 fi
79 }
80
81 for d; do
82 vol=${d##*/}
83 # second field, non-comment line == $d
84 dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab /etc/mtab|head -n1)
85 d dev=$dev
86 subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab /etc/mtab|head -n1)
87 d subvol_dir=$subvol_dir
88 # note, we need $dev because $d might not be mounted, and we do this loop
89 # because the device in fstab for the rootfs can be different.
90 for devx in $(btrfs fi show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
91 root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab|head -n1)
92 if [[ $root_dir ]]; then break; fi
93 done
94 if [[ ! $root_dir ]]; then
95 echo "$0: error could not find root subvol mount for $dev" >&2
96 exit 1
97 fi
98 svp=$root_dir/$subvol_dir
99 d "svp=$svp # subvolume path"
100
101 snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
102 if [[ ! $snaps ]]; then
103 # no snapshots yet
104 echo "$0: warning: no snapshots found at $root_dir/btrbk/$subvol_dir.20*. this is expected for a brand new volume"
105 continue
106 fi
107
108 # get info on last received sub
109 last_received_cgen=0
110 for f in ${snaps[@]}; do
111 show="$(btrfs sub show $f)"
112 if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
113 cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
114 if [[ $cgen -gt $last_received_cgen ]]; then
115 last_received_cgen=$cgen
116 last_received=$f
117 fi
118 fi
119 done
120 d last_received_cgen=$cgen
121 d last_received=$f
122
123 # Get last_snap by date.
124 # when a btrbk bugfix makes it into the distro,
125 # we might replace this with btrbk list latest /mnt/root/$vol | ...
126 last_snap=$(
127 for s in ${snaps[@]}; do
128 f=${s##*/}
129 unix_time=$(date -d $(sed -r 's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s)
130 printf "%s %s\n" $unix_time $s
131 done | sort -r | head -n 1 | awk '{print $2}'
132 )
133 if [[ ! $last_snap ]]; then
134 # should not happen.
135 echo "$0: error: could not find latest snapshot for $svp among ${snaps[*]}" >&2
136 exit 1
137 fi
138
139 if [[ ! -e $svp ]]; then
140 echo "$0: warning: subvol does not exist: $svp"
141 echo "$0 assuming this host was just for receiving and latest snap is freshest"
142 freshest_snap=$last_snap
143 stale=true
144 stale-file
145 continue
146 fi
147
148
149 # if there is a last_received, we can assume stale or fresh if we are newer/older
150 if [[ $last_received ]]; then
151 svp_cgen=$(btrfs sub show $svp | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
152 d svp_cgen=$svp_cgen
153 if [[ $svp_cgen -ge $last_received_cgen ]]; then
154 stale=false
155 else
156 echo "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
157 freshest_snap=$last_received
158 stale=true
159 fi
160 stale-file
161 continue
162 fi
163
164 # fallback to using last_snap as the freshest
165 freshest_snap=$last_snap
166 stale=true
167 # fresh if $svp has $last_snap as a snapshot,
168 if btrfs sub show $svp 2>/dev/null | sed '0,/^\s*Snapshot(s):/d;s/^\s*//' | \
169 grep -xF btrbk/$last_snap &>/dev/null; then
170 stale=false
171 else # or else $svp is a snapshot of $last_snap. we use a uuid
172 # comparison, which if I remember from the docs, is a bit more
173 # robust, perhaps to renames.
174 last_snap_uuid=$(btrfs sub show $last_snap| awk '$1 == "UUID:" {print $2}')
175 if btrfs sub show $svp| grep "^\s*Parent UUID:\s*$last_snap_uuid$" &>/dev/null; then
176 stale=false
177 fi
178 fi
179
180 stale-file
181 done